from enum import Enum

class ResponseStatus(Enum):
    OK = "ok"
    ERROR = "error"
    INVALID = "invalid"
    
class ExploitStatus(Enum):
    active = 'active'
    disabled = 'disabled'

class AuthStatus(Enum):
    ok = "ok"
    nologin = "nologin"
    wrong = "wrong"
    invalid = "invalid"

class GroupStatus(Enum):
    active = 'active'
    inactive = 'inactive'

class FlagStatus(Enum):
    ok = 'ok'
    wait = 'wait'
    timeout = 'timeout'
    invalid = 'invalid'

class AttackExecutionStatus(Enum):
    done = 'done'
    noflags = 'noflags'
    crashed = 'crashed'

class Language(Enum):
    python = "python"
    java = "java"
    javascript = "javascript"
    typescript = "typescript"
    csharp = "c#"
    cpp = "c++"
    php = "php"
    r = "r"
    kotlin = "kotlin"
    go = "go"
    ruby = "ruby"
    rust = "rust"
    lua = "lua"
    dart = "dart"
    perl = "perl"
    haskell = "haskell"
    other = "other"

class MessageStatusLevel(Enum):
    info = "info"
    warning = "warning"
    error = "error"    

class AttackMode(Enum):
    WAIT_FOR_TIME_TICK = "wait-for-time-tick"
    TICK_DELAY = "tick-delay"
    LOOP_DELAY = "loop-delay"

class SetupStatus(Enum):
    SETUP = "setup"
    RUNNING = "running"

class GroupEventRequestType(Enum):
    DYNAMIC_TIMEOUT = "dynamic_timeout"
    DEADLINE_TIMOEOUT = "deadline_timeout"
    ATTACK_REQUEST = "attack_request"
    ATTACK_KILL = "attack_kill"
    KILLALL_ATTACKS = "killall_attacks"
    RUNNING_STATUS = "running_status"
    EXPLOIT_PULL = "exploit_pull"

class GroupEventResponseType(Enum):
    ATTACK_ENDED = "attack_ended"
    SET_RUNNING_STATUS = "set_running_status"

#Utility functions

def get_lang(lang: str|Language) -> Language:
    if isinstance(lang, Language):
        return lang
    res = [ele for ele in list(Language) if ele.value == lang]
    if len(res) == 0:
        return Language.other
    return res[0]
