from pydantic import BaseModel, AwareDatetime
from exploitfarm.models.dbtypes import TeamID

###-- Teams Models --###

class TeamDTO(BaseModel):
    id: TeamID
    name: str|None
    short_name: str|None
    host: str
    created_at: AwareDatetime

class TeamAddForm(BaseModel):
    name: str|None = None
    short_name: str|None = None
    host: str

class TeamEditForm(BaseModel):
    id: TeamID
    name: str|None = None
    short_name: str|None = None
    host: str|None = None
